//===========================================================================
//  @(#) $Name: cflowd-2-1-b1 $
//  @(#) $Id: FlowFilterLex.cc,v 1.6 1998/12/12 09:53:19 dwm Exp $
//===========================================================================
//  CAIDA Copyright Notice
//
//  By accessing this software, cflowd++, you are duly informed
//  of and agree to be bound by the conditions described below in this
//  notice:
//
//  This software product, cflowd++, is developed by Daniel W. McRobb, and
//  copyrighted(C) 1998 by the University of California, San Diego
//  (UCSD), with all rights reserved.  UCSD administers the CAIDA grant,
//  NCR-9711092, under which part of this code was developed.
//
//  There is no charge for cflowd++ software. You can redistribute it
//  and/or modify it under the terms of the GNU General Public License,
//  v.  2 dated June 1991 which is incorporated by reference herein.
//  cflowd++ is distributed WITHOUT ANY WARRANTY, IMPLIED OR EXPRESS, OF
//  MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE or that the use
//  of it will not infringe on any third party's intellectual property
//  rights.
//
//  You should have received a copy of the GNU GPL along with cflowd++.
//  Copies can also be obtained from:
//
//    http://www.gnu.org/copyleft/gpl.html
//
//  or by writing to:
//
//    University of California, San Diego
//
//    SDSC/CAIDA
//    9500 Gilman Dr., MS-0505
//    La Jolla, CA 92093 - 0505  USA
//
//  Or contact:
//
//    info@caida.org
//===========================================================================

#include <string>
#include <vector>

#include "CflowdFlowFilter.hh"
#include "flowfilt.tab.h"

extern int       flowfiltlval;

static const string rcsid = "@(#) $Name: cflowd-2-1-b1 $ $Id: FlowFilterLex.cc,v 1.6 1998/12/12 09:53:19 dwm Exp $";

static const CflowdFlowFilter            *g_flowFilter = (CflowdFlowFilter *)0;
static CflowdFlowFilter::const_iterator   g_flowFilterIter;

//-------------------------------------------------------------------------
// void SetFlowFilter(const CflowdFlowFilter * flowFilter) 
//.........................................................................
//  
//-------------------------------------------------------------------------
void SetFlowFilter(const CflowdFlowFilter * flowFilter)
{
  g_flowFilter = flowFilter;
  g_flowFilterIter = (*g_flowFilter).begin();
  return;
}

//-------------------------------------------------------------------------
//                         void RewindFlowFilter()                         
//.........................................................................
//  
//-------------------------------------------------------------------------
void RewindFlowFilter()
{
  g_flowFilterIter = (*g_flowFilter).begin();
  return;
}

//-------------------------------------------------------------------------
//                            int flowfiltlex()                            
//.........................................................................
//  
//-------------------------------------------------------------------------
int flowfiltlex()
{
  if (g_flowFilter == (CflowdFlowFilter *)0)
    return(0);
  
  if (g_flowFilterIter == (*g_flowFilter).end())
    return(0);

  int returnVal = (*g_flowFilterIter).lexToken;
  switch (returnVal) {
    case FIELDNAME:
      flowfiltlval = (*g_flowFilterIter).fieldMask;
      break;
    case INTEGER:
      flowfiltlval = (*g_flowFilterIter).value;
      break;
    default:
      break;
  }
  g_flowFilterIter++;

  return(returnVal);
}
